var JSONPAdapter = function() {

    this.initialize = function(data) {
        url = typeof data !== 'undefined' ? data : "http://do.diba.cat/api/dataset";
        var deferred = $.Deferred();
        deferred.resolve();
        return deferred.promise();
    }
    /*
     * Funcio que busca en el webservice per id
     */
    this.buscarPerId = function(id) {
        return $.ajax({url: url + "/contactes/camp-contacte_id/" + id+"?callback=JSON_CALLBACK", dataType: "json"});
    }

    /*
     * Funcio que busca en el webservice per tots els camps de la cerca si no estan buits.
     * 
     */
    this.buscarResultats = function(searchKey,organic_id, recinte_id, ordre, pag, per_pag) {
    	pag__ini = (parseInt(pag) - 1) * parseInt(per_pag) + 1;
    	url_continuacio ="/contactes";
    	if(typeof(searchKey)  != "undefined" && searchKey != ""){
    		//Separemm la paraula per espais en blanc
    		var substr = searchKey.split(' ');
    		//Aqu cerquem tants cops com paraules tinguem a la cerca
    		//El camp-cerca cont tot els valors dels altres camps, perqu la cerca sigui molt rpida
    		 for(var i = 0; i < substr.length; i++)
    		    {
    			 	//Convertim a mnscules, faltaria treure els accnts per afinar la cerca.
    			   url_continuacio +="/camp-cerca-like/"+substr[i].toLowerCase();
    		    }
    	} 
    	if(typeof(organic_id)  != "undefined" && organic_id != ""){
    		url_continuacio +="/camp-organic/"+organic_id;
    	}
   		if(typeof(recinte_id)  != "undefined" && recinte_id != "") {
    		url_continuacio +="/camp-id_centre_treball/"+recinte_id;
    	}
    	if(typeof(ordre)  != "undefined" && ordre != ""){
    		url_continuacio +="/ord-" + ordre + "/asc";
    	}else{
    		url_continuacio +="/ord-cognoms/asc";
    	}
    	url_continuacio += "/pag-ini/" + pag__ini.toString() + "/pag-fi/" + pag*per_pag+"?callback=JSON_CALLBACK";
    	resposta = $.ajax({url: url + url_continuacio, 
			       dataType: "json",
			       type: 'GET', 
			       crossDomain: true,
		            error:function(e) {
		                 alert("Error, no es pot accedir al web service");
		            }
			       });
       return resposta;  
     }
    
    /*
     * Funcio que retorna els orgncis del webservice d'orgnics
     * 
     */
    this.findOrganic = function() {
       resposta = $.ajax({url: url + "/organics/pag-ini/1/pag-fi/20?callback=JSON_CALLBACK", 
			       dataType: "json",
			       type: 'GET', 
			       crossDomain: true,
		            error:function(e) {
		                 alert("Error, no es pot accedir al web service");
		            }
			       });
			       
       return resposta;  
     }
    
    
    /*
     * Funcio que retorna els recintes del webservice de recintes
     * 
     */
    this.findRecinte = function() {
        resposta = $.ajax({url: url + "/recintes?callback=JSON_CALLBACK", 
 			       dataType: "json",
 			       type: 'GET', 
 			       crossDomain: true,
 		            error:function(e) {
 		                 alert("Error, no es pot accedir al web service");
 		            }
 			       });
 			       
        return resposta;  
      }
    var url;

}
